Subject: [AAA-WG]: DPA DPR processing and the state machine

From: Avi Lior <[email-masked]>
Date: Fri, 26 Nov 2004 16:43:23 -0500

The peer state machine I think is not right:

 I-Open           Send-Message     I-Snd-Message    I-Open
                    I-Rcv-Message    Process          I-Open
                    I-Rcv-DWR        Process-DWR,     I-Open
                                     I-Snd-DWA
                    I-Rcv-DWA        Process-DWA      I-Open
                    R-Conn-CER       R-Reject         I-Open
                    Stop             I-Snd-DPR        Closing
                    I-Rcv-DPR        I-Snd-DPA,       Closed
                                     I-Disc
                   
Looking at state I-Open for example.  When I-Rcv-DPR comes in we peform two
actions:
We send an answer I-Snd-DPA and disconnect the the transport.

But 3588 says: (Section 5.4.2)

Upon receipt of this message (DPA), the transport connection is shutdown.

Also section 5.4 says:

 The receiver of the Disconnect-Peer-Answer initiates the transport
   disconnect.

But in the above statemachine the sender of the DPA is disconnecting the
transport.

I belive that the correct behavior is:
The receiver of the DPR simply replies with a DPA and remains in the same
state.
The original sender of the DPR upon receiving the DPA (he is is in the
closing state) will disconnect the transport which will trigger then
generate an Peer-Disc etc..

-----------------------------
Avi Lior
Bridgewater Systems Corp.
Phone: 613.591.9104 x 6417
Cell   : 613.297.2177